diff -ruNp r8169-6.016.00/src/r8169_n.c r8169-6.016.00-vr5/src/r8169_n.c
--- r8169-6.016.00/src/r8169_n.c	2011-12-28 10:07:59.000000000 +0400
+++ r8169-6.016.00-vr5/src/r8169_n.c	2012-03-05 04:22:35.000000000 +0400
@@ -3358,6 +3358,7 @@ static int rtl8169_xmit_frags(struct rtl
 	struct skb_shared_info *info = skb_shinfo(skb);
 	unsigned int cur_frag, entry;
 	struct TxDesc *txd = NULL;
+	struct device *d = &tp->pci_dev->dev;
 
 	entry = tp->cur_tx;
 	for (cur_frag = 0; cur_frag < info->nr_frags; cur_frag++) {
@@ -3369,9 +3370,9 @@ static int rtl8169_xmit_frags(struct rtl
 		entry = (entry + 1) % NUM_TX_DESC;
 
 		txd = tp->TxDescArray + entry;
-		len = frag->size;
-		addr = ((void *) page_address(frag->page)) + frag->page_offset;
-		mapping = pci_map_single(tp->pci_dev, addr, len, PCI_DMA_TODEVICE);
+		len = skb_frag_size(frag);
+		addr = skb_frag_address(frag);
+		mapping = dma_map_single(d, addr, len, DMA_TO_DEVICE);
 
 		/* anti gcc 2.95.3 bugware (sic) */
 		status = opts1 | len | (RingEnd * !((entry + 1) % NUM_TX_DESC));
@@ -3753,31 +3754,23 @@ static irqreturn_t rtl8169_interrupt(int
 {
 	struct net_device *dev = (struct net_device *) dev_instance;
 	struct rtl8169_private *tp = netdev_priv(dev);
-	int boguscnt = max_interrupt_work;
 	void __iomem *ioaddr = tp->mmio_addr;
 	int status;
 	int handled = IRQ_NONE;
 
-	do {
-		status = RTL_R16(IntrStatus);
+	status = RTL_R16(IntrStatus);
+	while (status && status != 0xffff) {
 
-		/* hotplug/major error/no more work/shared irq */
-		if ((status == 0xFFFF) || !status)
-			break;
+//		/* hotplug/major error/no more work/shared irq */
+//		if ((status == 0xFFFF) || !status)
+//			break;
 
 		handled = IRQ_HANDLED;
 
 		if (unlikely(!netif_running(dev))) {
 			rtl8169_asic_down(ioaddr);
-			goto out;
-		}
-
-		status &= tp->intr_mask;
-		RTL_W16(IntrStatus,
-			(status & RxFIFOOver) ? (status | RxOverflow) : status);
-
-		if (!(status & rtl8169_intr_mask))
 			break;
+		}
 
 		if (unlikely(status & SYSErr)) {
 			rtl8169_pcierr_interrupt(dev);
@@ -3787,8 +3780,8 @@ static irqreturn_t rtl8169_interrupt(int
 		if (status & LinkChg)
 			rtl8169_check_link_status(dev, tp, ioaddr);
 
-#ifdef CONFIG_R8169_NAPI
-		if (status & rtl8169_napi_event) {
+		rtl_rmb();
+		if (status & tp->intr_mask & rtl8169_napi_event) {
 			RTL_W16(IntrMask, rtl8169_intr_mask & ~rtl8169_napi_event);
 			tp->intr_mask = ~rtl8169_napi_event;
 
@@ -3799,31 +3792,10 @@ static irqreturn_t rtl8169_interrupt(int
 				       dev->name, status);
 			}
 		}
-		break;
-#else
-		/* Rx interrupt */
-		if (status & (RxOK | RxOverflow | RxFIFOOver)) {
-			rtl8169_rx_interrupt(dev, tp, tp->mmio_addr, ~(u32)0);
-		}
-
-		/* Tx interrupt */
-		if (status & (TxOK | TxErr)) {
-			rtl8169_tx_interrupt(dev, tp, ioaddr);
-		}
-#endif
-
-		boguscnt--;
-	} while (boguscnt > 0);
-
-	if (boguscnt <= 0) {
-		if (netif_msg_intr(tp) && net_ratelimit()) {
-			printk(KERN_WARNING
-			       "%s: Too much work at interrupt!\n", dev->name);
-		}
-		/* Clear all interrupt sources. */
-		RTL_W16(IntrStatus, 0xffff);
+		RTL_W16(IntrStatus,
+			(status & RxFIFOOver) ? (status | RxOverflow) : status);
+		status = RTL_R16(IntrStatus);
 	}
-out:
 	return IRQ_RETVAL(handled);;
 }
 
